#include <print>
#include <vector>

int main()
{
    /* Different constructors of the vector class */
    std::vector<int> empty_vector; // Empty int vector.
    std::vector<int> vector_default_value(5); // Int vector of size 5 with default value.
    std::vector vector_custom_value(5, 999); // Vector of size 5 with custom value. the value type (int) is deduced!
    std::vector vector_initializer_list {1, 2, 3}; // Vector with the content {1, 2, 3}. Again no template argument.
    std::vector vector_copy_constructed {vector_default_value}; // This is a copy.

    // Access the size of the vector
    std::println("vector_default_value.size() = {}", vector_default_value.size());

    // Append an element
    vector_default_value.push_back(100);
    std::println("vector_default_value.size() = {}", vector_default_value.size());

    // To check if the vector is empty, we can compare its size to zero
    // or use the `empty` method.
    if (empty_vector.empty())
        std::println("empty_vector.empty() is true");

    // To access an element us the `at` method
    std::println("vector_custom_value.at(2) = {}", vector_custom_value.at(2));
    
    // Works the same when modifying an element
    vector_custom_value.at(2) = 777;
    std::println("vector_custom_value.at(2) = {}", vector_custom_value.at(2));
}