#include <algorithm>
#include <print>
#include <ranges>
#include <vector>

int main()
{
    std::vector my_vector {35, 71, 85, 64, 77, 94,  0, 81, 74, 86};

    std::println("Range-based for loop");
    for (const auto& item : my_vector) {
        std::println("{}", item);
    }

    std::println("\nRange-based for loop with index");
    for (const auto& [idx, item] : std::views::enumerate(my_vector)) {
        std::println("{}: {}", idx, item);
    }

    std::println("\nC-style for loop");
    for (unsigned idx = 0; idx < my_vector.size(); idx++) {
        std::println("{}: {}", idx, my_vector.at(idx));
    }

    std::println("\nAn alternative to C-style loops");
    for (const auto idx : std::views::iota(0u, my_vector.size())) {
        std::println("{}: {}", idx, my_vector.at(idx));
    }

    std::println("\nOften we use algorithms");
    std::ranges::for_each(my_vector, [](const auto& item){
        std::println("{}", item);
    });
}