#include <print>
#include <ranges>
#include <vector>

bool is_strictly_increasing(const std::vector<int>& sequence)
{
    for (auto i : std::views::iota(1u, sequence.size()))
        if (sequence.at(i-1) >= sequence.at(i))
            return false;
    return true;
}

int main()
{
    const std::vector primes = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29};
    std::print("Prime sequence is ");
    if (!is_strictly_increasing(primes)) std::print("not ");
    std::println("strictly increasing.");

    const std::vector fibonacci = {0, 1, 1, 2, 3, 5, 8, 13, 21, 34};
    std::print("Fibonacci sequence is ");
    if (!is_strictly_increasing(fibonacci)) std::print("not ");
    std::println("strictly increasing.");
}