#include <algorithm>
#include <print>
#include <ranges>
#include <string>
#include <vector>

bool check_luhn(const std::vector<int>& number)
{
    int sum = 0;
    auto view = number | std::views::reverse | std::views::drop(1);
    for (const auto [i, digit_] : std::views::enumerate(view)) {
        auto digit = digit_;
        if (i % 2 == 0)
            digit *= 2;
        if (digit > 9)
            digit -= 9;
        sum += digit;
    }
    const int check_digit_calculated = (10 - (sum % 10)) % 10;
    const int check_digit = number.back();
    return check_digit_calculated == check_digit;
}

int main()
{
    /*** Please do not save your real credit card information in this source file. ***/
    const std::vector number {2, 4, 4, 5, 3, 9, 4, 2, 5, 8, 8, 1, 1, 3, 6, 9};

    if (check_luhn(number))
        std::println("Validation succeeded.");
    else
        std::println("Validation failed.");
}